﻿
//Make requested change to JSON data
function change(object,newer,desc) 
{
  /*var older = eval(object);
  
  if(newer.constructor == Object) {
    older = JSON.stringify(older);
    newer = JSON.stringify(newer);
  }*/
  
  recordChange(object,eval(object),newer,desc);
  eval(object+"=newer");
  
  if (/json.students\[[0-9]+\].points\[/.test(object)) {
    var j = object.match(/[0-9]+/)[0]; //student index
    updatePercentageFor(j);
  } else if (/json.assignments\[[0-9]+\].max/.test(object)) {
    updatePercentages();
  }
}

// Record JSON data changes to undo-redo history
function recordChange(object,older,newer,desc)
{
  if (json.history_index > 0) {
    json.history.splice(0,json.history_index);
    json.history_index = 0;
  }
  if (/undo/.test(newer)) newer = newer..split(/,"history":\[.+\],"history_index":[0-9]+/).join("");
  json.history.unshift({undo:object+"='"+escape(older)+"'", redo:object+"='"+escape(newer)+"'"});
  
  if (json.history.length > 20) json.history.pop() //limits undo-redo history to last 20 changes
  
  if (saving) el("save_button").disabled = false;
  el("undo_button").disabled = false;
  el("undo_button").title = "Undo "+desc;
  el("redo_button").disabled = true;
}


function undo()
{
  var steps = 1;
  for (var i = 1; i <= steps; i++) {
    var statement = json.history[json.history_index].undo.split("=");
    if (statement[0] == "json.students" || statement[0] == "json.assignments" || statement[0] == "json") 
      eval(statement[0]+"="+eval(unescape(statement[1])));
    else
      eval(statement[0]+"="+unescape(statement[1]));
    json.history_index += 1;
  }
  importData();
  if (json.history_index >= json.history.length) el("undo_button").disabled = true;
  el("redo_button").disabled = false;
}

function redo(steps)
{
  var steps = 1;
  for (var i = 1; i <= steps; i++) {
    json.history_index += -1;
    var statement = json.history[json.history_index].redo.split("=");
    if (statement[0] == "json.students" || statement[0] == "json.assignments" || statement[0] == "json")
      eval(statement[0]+"="+eval(unescape(statement[1])));
    else
      eval(statement[0]+"="+unescape(statement[1]));
  }
  importData();
  if (json.history_index == 0) el("redo_button").disabled = true;
  el("undo_button").disabled = false;
}




function revert()
{
  importData(backup);
  save();
  el("undo_button").disabled = true;
  el("redo_button").disabled = false;
}

function unrevert()
{
  importData(backup);
  save();
  el("redo_button").disabled = true;
  el("undo_button").disabled = false;
}
